aboutsummaryrefslogtreecommitdiff
path: root/git-push.sh
diff options
context:
space:
mode:
Diffstat (limited to 'git-push.sh')
-rwxr-xr-xgit-push.sh52
1 files changed, 52 insertions, 0 deletions
diff --git a/git-push.sh b/git-push.sh
new file mode 100755
index 000000000..00d715059
--- /dev/null
+++ b/git-push.sh
@@ -0,0 +1,52 @@
+#!/bin/sh
+. git-sh-setup || die "Not a git archive"
+
+# Parse out parameters and then stop at remote, so that we can
+# translate it using .git/branches information
+has_all=
+has_force=
+has_exec=
+remote=
+
+while case "$#" in 0) break ;; esac
+do
+ case "$1" in
+ --all)
+ has_all=--all ;;
+ --force)
+ has_force=--force ;;
+ --exec=*)
+ has_exec="$1" ;;
+ -*)
+ die "Unknown parameter $1" ;;
+ *)
+ set x "$@"
+ shift
+ break ;;
+ esac
+ shift
+done
+case "$#" in
+0)
+ die "Where would you want to push today?" ;;
+esac
+
+. git-parse-remote
+remote=$(get_remote_url "$@")
+case "$has_all" in
+--all) set x ;;
+'') set x $(get_remote_refs_for_push "$@") ;;
+esac
+shift
+
+case "$remote" in
+http://* | https://* | git://* | rsync://* )
+ die "Cannot push to $remote" ;;
+esac
+
+set x "$remote" "$@"; shift
+test "$has_all" && set x "$has_all" "$@" && shift
+test "$has_force" && set x "$has_force" "$@" && shift
+test "$has_exec" && set x "$has_exec" "$@" && shift
+
+exec git-send-pack "$@"